SHMGET(2)

NAME
shmget - get shared memory area identifier

SYNOPSIS
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
int
shmget(key_t key, size_t size, int shmflg);

DESCRIPTION
shmget() returns the shared memory identifier associated with the key key.

A shared memory segment is created if either key is equal to IPC_PRIVATE, or key does not have a shared memory segment identifier associated with it, and the IPC_CREAT bit is set in shmflg.

If a new shared memory segment is created, the data structure associated with it (the shmid_ds structure, see shmctl(2)) is initialized as follows:

•   shm_perm.cuid and shm_perm.uid are set to the effective uid of the calling process.

•   shm_perm.gid and shm_perm.cgid are set to the effective gid of the calling process.

•   shm_perm.mode is set to the lower 9 bits of shmflg.

•   shm_lpid, shm_nattch, shm_atime, and shm_dtime are set to 0.

•   shm_ctime is set to the current time.

•   shm_segsz is set to the value of size.

RETURN VALUES
Upon successful completion a positive shared memory segment identifier is returned. Otherwise, -1 is returned and the global variable errno is set to indicate the error.

ERRORS

[EACCES]
    A shared memory segment is already associated with key and the caller has no permission to access it.

[EEXIST]
    Both IPC_CREAT and IPC_EXCL are set in shmflg, and a shared memory segment is already associated with key.

[EINVAL]
    A shared memory segment is already associated with key and its size is less than the requested size.

[ENOSPC]
    A new shared memory identifier could not be created because the system limit for the number of shared memory identifiers has been reached.

[ENOENT]
    IPC_CREAT was not set in shmflg and no shared memory segment associated with key was found.

[ENOMEM]
    There is not enough memory left to create a shared memory segment of the requested size.

SEE ALSO
ipcrm(1), ipcs(1), mmap(2), shmat(2), shmctl(2), ftok(3)